﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using _1C.V8.Data;
using _1C.V8.WebControls;

namespace ITS08
{
	/// <summary>
	/// Summary description for V8WebItemForm1.
	/// </summary>
    public class V8WebItemForm1 : System.Web.UI.Page
    {
        /// <summary>
        /// Заголовок страницы.
        /// </summary>
        protected Literal Title;

        /// <summary>
        /// Источник данных.
        /// </summary>
        protected V8ObjectDataSource ItemDataSource;

        /// <summary>
        /// Командная панель.
        /// </summary>
        protected _1C.V8.WebControls.V8CommandPanel menuPanel;

        /// <summary>
        /// Командная панель формы.
        /// </summary>
        protected _1C.V8.WebControls.V8CommandPanel mainPanel;

        /// <summary>
        /// Редактирование полей
        /// </summary>
        protected System.Web.UI.WebControls.Label LabelКод;
        protected V8TextBox Код;
        protected System.Web.UI.WebControls.Label LabelНаименование;
        protected V8TextBox Наименование;
        protected System.Web.UI.WebControls.Label LabelРодитель;
        protected V8TextBox Родитель;
        protected System.Web.UI.WebControls.Label LabelЗакупочнаяЦена;
        protected V8TextBox ЗакупочнаяЦена;
        protected System.Web.UI.WebControls.Label LabelПолноеНаименование1;
        protected _1C.V8.WebControls.V8RecordDataSource DSОптоваяЦена;
        protected _1C.V8.WebControls.V8RecordDataSource DSМелкоОптоваяЦена;
        protected _1C.V8.WebControls.V8RecordDataSource DSРозничнаяЦена;
        protected _1C.V8.WebControls.V8TextBox V8TextBox1;
        protected _1C.V8.WebControls.V8TextBox V8TextBox2;
        protected _1C.V8.WebControls.V8TextBox V8TextBox3;
        protected V8TextBox ПолноеНаименование1;

        
        
        #region Web Form Designer generated code
        override protected void OnInit(EventArgs e)
        {
            InitializeComponent();
            base.OnInit(e);
        }
		
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {    
            this.ItemDataSource.OnWrite += new _1C.V8.WebControls.V8ItemDataSource.V8ItemDataSourceEventHandler(this.ItemDataSource_OnWrite);
            this.ItemDataSource.OnInitObject += new _1C.V8.WebControls.V8ItemDataSource.V8ItemDataSourceInitObjectEventHandler(this.ItemDataSource_OnInitObject);
            this.ItemDataSource.BeforeSetDataToForm += new _1C.V8.WebControls.V8ItemDataSource.V8ItemDataSourceEventHandler(this.ItemDataSource_BeforeSetDataToForm);
            this.ItemDataSource.OnRead += new _1C.V8.WebControls.V8ItemDataSource.V8ItemDataSourceEventHandler(this.ItemDataSource_OnRead);
            this.DSОптоваяЦена.BeforeWrite += new _1C.V8.WebControls.V8ItemDataSource.V8ItemDataSourceEventHandler(this.DSОптоваяЦена_BeforeWrite);
            this.DSМелкоОптоваяЦена.BeforeWrite += new _1C.V8.WebControls.V8ItemDataSource.V8ItemDataSourceEventHandler(this.DSМелкоОптоваяЦена_BeforeWrite);
            this.DSРозничнаяЦена.BeforeWrite += new _1C.V8.WebControls.V8ItemDataSource.V8ItemDataSourceEventHandler(this.DSРозничнаяЦена_BeforeWrite);
            this.Load += new System.EventHandler(this.Page_Load);
            this.PreRender += new System.EventHandler(this.Page_PreRender);

        }
        #endregion

        private void Page_Load(object sender, System.EventArgs e)
        {
            // проверка прав на просмотр таблицы
            if (!ItemDataSource.CheckAccessRight(V8Rights.View))
            {
                V8WebUtil.RegisterShowErrorScript( _1C.V8.Data.V8.GetString("err_accessRightViolation"), this, true);
                Response.End();
                return;
            }

            if (!IsPostBack)
                Title.Text = ItemDataSource.TableInfo.Presentation;
        }

        private void Page_PreRender(object sender, System.EventArgs e)
        {
            switch (ItemDataSource.FormMode)
            {
                case V8ItemDataSourceMode.New :
                    menuPanel.Buttons[1].Text = _1C.V8.Data.V8.GetString("V8ItemDataSourceMode.New");
                    break;
                case V8ItemDataSourceMode.Edit :
                    menuPanel.Buttons[1].Text = _1C.V8.Data.V8.GetString("V8ItemDataSourceMode.Edit");
                    break;
                case V8ItemDataSourceMode.Copy :
                    menuPanel.Buttons[1].Text = _1C.V8.Data.V8.GetString("V8ItemDataSourceMode.Copy");
                    break;
                case V8ItemDataSourceMode.InputOnBasis :
                    menuPanel.Buttons[1].Text = _1C.V8.Data.V8.GetString("V8ItemDataSourceMode.InputOnBasis");
                    break;
            }
        }

        private void FillValues()
        {
            DSОптоваяЦена.KeyValues = new object[2];
            DSМелкоОптоваяЦена.KeyValues = new object[2];
            DSРозничнаяЦена.KeyValues = new object[2];

            DSОптоваяЦена.KeyValues[0] = ItemDataSource.KeyValue;
            DSМелкоОптоваяЦена.KeyValues[0] = ItemDataSource.KeyValue;
            DSРозничнаяЦена.KeyValues[0] = ItemDataSource.KeyValue;

            V8DbSelectCommand command = new V8DbSelectCommand();
            command.Connection = ItemDataSource.Connection;

            bool needClose = ItemDataSource.Connection.State == ConnectionState.Closed;
            if (ItemDataSource.Connection.State == ConnectionState.Closed)
                ItemDataSource.Connection.Open();
            try
            {
                command.CommandText = "SELECT Ссылка FROM Справочник.ТипыЦен WHERE Наименование=\"Оптовая\"";
                DSОптоваяЦена.KeyValues[1] = command.ExecuteScalar();

                command.CommandText = "SELECT Ссылка FROM Справочник.ТипыЦен WHERE Наименование=\"Мелкооптовая\"";
                DSМелкоОптоваяЦена.KeyValues[1] = command.ExecuteScalar();

                command.CommandText = "SELECT Ссылка FROM Справочник.ТипыЦен WHERE Наименование=\"Розничная\"";
                DSРозничнаяЦена.KeyValues[1] = command.ExecuteScalar();
            }
            finally
            {
                if (needClose)
                    ItemDataSource.Connection.Close();
            }
        }

        private void ItemDataSource_OnRead(object source, System.EventArgs e)
        {
            FillValues();

            DSОптоваяЦена.Connection = ItemDataSource.Connection;
            DSОптоваяЦена.Read(DSОптоваяЦена.KeyValues);
            if (DSОптоваяЦена.dataSet.Tables[0].Rows.Count == 0)
                DSОптоваяЦена.InitNew();

            DSМелкоОптоваяЦена.Connection = ItemDataSource.Connection;
            DSМелкоОптоваяЦена.Read(DSМелкоОптоваяЦена.KeyValues);
            if (DSМелкоОптоваяЦена.dataSet.Tables[0].Rows.Count == 0)
                DSМелкоОптоваяЦена.InitNew();

            DSРозничнаяЦена.Connection = ItemDataSource.Connection;
            DSРозничнаяЦена.Read(DSРозничнаяЦена.KeyValues);
            if (DSРозничнаяЦена.dataSet.Tables[0].Rows.Count == 0)
                DSРозничнаяЦена.InitNew();
        }

        private void ItemDataSource_OnInitObject(object source, _1C.V8.WebControls.V8ItemDataSourceInitObjectEventArgs e)
        {
            FillValues();

            DSОптоваяЦена.Connection = ItemDataSource.Connection;
            DSОптоваяЦена.InitNew();

            DSМелкоОптоваяЦена.Connection = ItemDataSource.Connection;
            DSМелкоОптоваяЦена.InitNew();

            DSРозничнаяЦена.Connection = ItemDataSource.Connection;
            DSРозничнаяЦена.InitNew();
        }

        private void ItemDataSource_BeforeSetDataToForm(object source, System.EventArgs e)
        {
            DSОптоваяЦена.SetDataToForm();
            DSМелкоОптоваяЦена.SetDataToForm();
            DSРозничнаяЦена.SetDataToForm();
        }

        private void ItemDataSource_OnWrite(object source, System.EventArgs e)
        {
            try
            {
                DSОптоваяЦена.Connection = ItemDataSource.Connection;
                DSОптоваяЦена.doSave();

                DSМелкоОптоваяЦена.Connection = ItemDataSource.Connection;
                DSМелкоОптоваяЦена.doSave();

                DSРозничнаяЦена.Connection = ItemDataSource.Connection;
                DSРозничнаяЦена.doSave();
            }
            catch (Exception ex)
            {
                V8WebUtil.RegisterShowErrorScript(ex.GetBaseException().Message, this, false);
            }
        }

        private void DSОптоваяЦена_BeforeWrite(object source, System.EventArgs e)
        {
            DataRow row = DSОптоваяЦена.dataSet.Tables[0].Rows[0];
            row["Номенклатура"] = ItemDataSource.KeyValue;
            row["ТипЦен"] = DSОптоваяЦена.KeyValues[1];
        }

        private void DSМелкоОптоваяЦена_BeforeWrite(object source, System.EventArgs e)
        {
            DataRow row = DSМелкоОптоваяЦена.dataSet.Tables[0].Rows[0];
            row["Номенклатура"] = ItemDataSource.KeyValue;
            row["ТипЦен"] = DSМелкоОптоваяЦена.KeyValues[1];
        }

        private void DSРозничнаяЦена_BeforeWrite(object source, System.EventArgs e)
        {
            DataRow row = DSРозничнаяЦена.dataSet.Tables[0].Rows[0];
            row["Номенклатура"] = ItemDataSource.KeyValue;
            row["ТипЦен"] = DSРозничнаяЦена.KeyValues[1];
        }
    }
}
